package io.reisub.dreambot.cagility;

import io.reisub.dreambot.cagility.tasks.HandleObstacle;
import io.reisub.dreambot.cagility.tasks.PickupMark;
import io.reisub.dreambot.util.CTaskScript;
import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.randomevents.GenieSolver;
import io.reisub.dreambot.util.tasks.Eat;
import io.reisub.dreambot.util.tasks.Run;
import io.reisub.dreambot.util.tasks.kitten.KittenTask;
import org.dreambot.api.methods.skills.Skill;
import org.dreambot.api.script.Category;
import org.dreambot.api.script.ScriptManifest;
import org.dreambot.api.script.TaskNode;

import java.awt.*;

@SuppressWarnings("unused")
@ScriptManifest(category = Category.AGILITY, name = "CAgility", description = "Runs laps for days", author = Constants.AUTHOR, version = 1.0)
public class CAgility extends CTaskScript {
    @Override
    public void onStart() {
        getRandomManager().registerSolver(new GenieSolver(GenieSolver.Skill.HERBLORE));

        getUI().addSkills(Skill.AGILITY);
        getUI().setCustomLines(1);

        TaskNode kittenTask = KittenTask.getInstance();
        if (kittenTask != null) {
            addNodes(kittenTask);
        }

        addNodes(
                new Eat(),
                new Run(),
                new HandleObstacle(HandleObstacle.Course.SEERS),
                new PickupMark()
        );
    }

    @Override
    public void onPaint(Graphics g) {
        super.onPaint(g);

        int marks = PickupMark.marksPickedUp;
        getUI().drawString("Marks picked up: " + marks + " (" + getUI().getHourlyRate(marks) + " per hour)");
    }
}
